// -*- c++ -*-
/* This is a generated file, do not edit.  Generated from template.macros.m4 */

#ifndef SIGC_SLOT_CONVERT_H
#define SIGC_SLOT_CONVERT_H

#include <sigc++/adaptor.h>
#include <sigcx/convert.h>

#include <yehia/script/any.h>
#include <yehia/script/types.h>
#include <yehia/script/class-builder.h>
#include <yehia/script/traits.h>


namespace Yehia
{

namespace Script
{















class Object;

struct LangConvertSlotNode : public SigC::AdaptorSlotNode
{
    Language& lang_;
    
    LangConvertSlotNode(SigC::FuncPtr proxy, const SigC::Node& s, 
	                Language& lang);
    virtual ~LangConvertSlotNode();
    
    static Object& from_script_proxy(const ParamList& params, void *data);
    static Any to_script_proxy(const std::list<Any>& anylist, void *data);
};

ObjectSlot lang_convert(const Slot& s, Language& l);
Slot lang_convert(const ObjectSlot& s, Language& l);


/****************************************************************
***** Adaptor Convert SigC::Slot 0
****************************************************************/

template <class R>
class MarshalWrapper0
{
    typedef typename MarshalTraits<R>::ArgType TR;
  public:
    static Any unmarshal(SigC::Slot0<R>& slot, const std::list<Any>& params)
    {
      if (params.size() < 0)
        throw BadParam();
      
      
      Any retval = MarshalTraits<R>::marshal(slot());
      return retval;
    }
    static R marshal(SigC::Slot1<Any,const std::list<Any>&>& slot)
    {
      std::list<Any> params;
      
      Any any_retval = slot(params);
      R retval;
      if (!any_retval.empty())
        retval = MarshalTraits<R>::unmarshal(any_retval);
      return retval;
    }
};

#ifdef SIGC_CXX_PARTIAL_SPEC
template <>
class MarshalWrapper0<void>
{
    
  public:
    static Any unmarshal(SigC::Slot0<void>& slot, const std::list<Any>& params)
    {
      if (params.size() < 0)
        throw BadParam();
      
      
      slot();
      return Any();
    }
    static void marshal(SigC::Slot1<Any,const std::list<Any>&>& slot)
    {
      std::list<Any> params;
      
      slot(params);
   }
};
#endif

template <class R>
SigC::Slot1<Any, const std::list<Any>&>
convert(const SigC::Slot0<R>& s)
  { return SigCX::convert(s, &MarshalWrapper0<R>::unmarshal); }

template <class R>
SigC::Slot0<R>
convert(const SigC::Slot1<Any, const std::list<Any>&>& s)
  { return SigCX::convert(s, &MarshalWrapper0<R>::marshal); }


/****************************************************************
***** Adaptor Convert SigC::Slot 1
****************************************************************/

template <class R,class P1>
class MarshalWrapper1
{
    typedef typename MarshalTraits<R>::ArgType TR; typedef typename MarshalTraits<P1>::ArgType TP1;
  public:
    static Any unmarshal(SigC::Slot1<R,P1>& slot, const std::list<Any>& params)
    {
      if (params.size() < 1)
        throw BadParam();
      std::list<Any>::const_iterator it = params.begin();
      TP1 p1_ = MarshalTraits<P1>::unmarshal(*it++);
      Any retval = MarshalTraits<R>::marshal(slot(p1_));
      return retval;
    }
    static R marshal(SigC::Slot1<Any,const std::list<Any>&>& slot,P1 p1)
    {
      std::list<Any> params;
      params.push_back(MarshalTraits<P1>::marshal(p1));
      Any any_retval = slot(params);
      R retval;
      if (!any_retval.empty())
        retval = MarshalTraits<R>::unmarshal(any_retval);
      return retval;
    }
};

#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1>
class MarshalWrapper1<void,P1>
{
    typedef typename MarshalTraits<P1>::ArgType TP1;
  public:
    static Any unmarshal(SigC::Slot1<void,P1>& slot, const std::list<Any>& params)
    {
      if (params.size() < 1)
        throw BadParam();
      std::list<Any>::const_iterator it = params.begin();
      TP1 p1_ = MarshalTraits<P1>::unmarshal(*it++);
      slot(p1_);
      return Any();
    }
    static void marshal(SigC::Slot1<Any,const std::list<Any>&>& slot,P1 p1)
    {
      std::list<Any> params;
      params.push_back(MarshalTraits<P1>::marshal(p1));
      slot(params);
   }
};
#endif

template <class R,class P1>
SigC::Slot1<Any, const std::list<Any>&>
convert(const SigC::Slot1<R,P1>& s)
  { return SigCX::convert(s, &MarshalWrapper1<R,P1>::unmarshal); }

template <class R,class P1>
SigC::Slot1<R,P1>
convert(const SigC::Slot1<Any, const std::list<Any>&>& s)
  { return SigCX::convert(s, &MarshalWrapper1<R,P1>::marshal); }


/****************************************************************
***** Adaptor Convert SigC::Slot 2
****************************************************************/

template <class R,class P1,class P2>
class MarshalWrapper2
{
    typedef typename MarshalTraits<R>::ArgType TR; typedef typename MarshalTraits<P1>::ArgType TP1; typedef typename MarshalTraits<P2>::ArgType TP2;
  public:
    static Any unmarshal(SigC::Slot2<R,P1,P2>& slot, const std::list<Any>& params)
    {
      if (params.size() < 2)
        throw BadParam();
      std::list<Any>::const_iterator it = params.begin();
      TP1 p1_ = MarshalTraits<P1>::unmarshal(*it++); TP2 p2_ = MarshalTraits<P2>::unmarshal(*it++);
      Any retval = MarshalTraits<R>::marshal(slot(p1_,p2_));
      return retval;
    }
    static R marshal(SigC::Slot1<Any,const std::list<Any>&>& slot,P1 p1,P2 p2)
    {
      std::list<Any> params;
      params.push_back(MarshalTraits<P1>::marshal(p1)); params.push_back(MarshalTraits<P2>::marshal(p2));
      Any any_retval = slot(params);
      R retval;
      if (!any_retval.empty())
        retval = MarshalTraits<R>::unmarshal(any_retval);
      return retval;
    }
};

#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,class P2>
class MarshalWrapper2<void,P1,P2>
{
    typedef typename MarshalTraits<P1>::ArgType TP1; typedef typename MarshalTraits<P2>::ArgType TP2;
  public:
    static Any unmarshal(SigC::Slot2<void,P1,P2>& slot, const std::list<Any>& params)
    {
      if (params.size() < 2)
        throw BadParam();
      std::list<Any>::const_iterator it = params.begin();
      TP1 p1_ = MarshalTraits<P1>::unmarshal(*it++); TP2 p2_ = MarshalTraits<P2>::unmarshal(*it++);
      slot(p1_,p2_);
      return Any();
    }
    static void marshal(SigC::Slot1<Any,const std::list<Any>&>& slot,P1 p1,P2 p2)
    {
      std::list<Any> params;
      params.push_back(MarshalTraits<P1>::marshal(p1)); params.push_back(MarshalTraits<P2>::marshal(p2));
      slot(params);
   }
};
#endif

template <class R,class P1,class P2>
SigC::Slot1<Any, const std::list<Any>&>
convert(const SigC::Slot2<R,P1,P2>& s)
  { return SigCX::convert(s, &MarshalWrapper2<R,P1,P2>::unmarshal); }

template <class R,class P1,class P2>
SigC::Slot2<R,P1,P2>
convert(const SigC::Slot1<Any, const std::list<Any>&>& s)
  { return SigCX::convert(s, &MarshalWrapper2<R,P1,P2>::marshal); }


/****************************************************************
***** Adaptor Convert SigC::Slot 3
****************************************************************/

template <class R,class P1,class P2,class P3>
class MarshalWrapper3
{
    typedef typename MarshalTraits<R>::ArgType TR; typedef typename MarshalTraits<P1>::ArgType TP1; typedef typename MarshalTraits<P2>::ArgType TP2; typedef typename MarshalTraits<P3>::ArgType TP3;
  public:
    static Any unmarshal(SigC::Slot3<R,P1,P2,P3>& slot, const std::list<Any>& params)
    {
      if (params.size() < 3)
        throw BadParam();
      std::list<Any>::const_iterator it = params.begin();
      TP1 p1_ = MarshalTraits<P1>::unmarshal(*it++); TP2 p2_ = MarshalTraits<P2>::unmarshal(*it++); TP3 p3_ = MarshalTraits<P3>::unmarshal(*it++);
      Any retval = MarshalTraits<R>::marshal(slot(p1_,p2_,p3_));
      return retval;
    }
    static R marshal(SigC::Slot1<Any,const std::list<Any>&>& slot,P1 p1,P2 p2,P3 p3)
    {
      std::list<Any> params;
      params.push_back(MarshalTraits<P1>::marshal(p1)); params.push_back(MarshalTraits<P2>::marshal(p2)); params.push_back(MarshalTraits<P3>::marshal(p3));
      Any any_retval = slot(params);
      R retval;
      if (!any_retval.empty())
        retval = MarshalTraits<R>::unmarshal(any_retval);
      return retval;
    }
};

#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,class P2,class P3>
class MarshalWrapper3<void,P1,P2,P3>
{
    typedef typename MarshalTraits<P1>::ArgType TP1; typedef typename MarshalTraits<P2>::ArgType TP2; typedef typename MarshalTraits<P3>::ArgType TP3;
  public:
    static Any unmarshal(SigC::Slot3<void,P1,P2,P3>& slot, const std::list<Any>& params)
    {
      if (params.size() < 3)
        throw BadParam();
      std::list<Any>::const_iterator it = params.begin();
      TP1 p1_ = MarshalTraits<P1>::unmarshal(*it++); TP2 p2_ = MarshalTraits<P2>::unmarshal(*it++); TP3 p3_ = MarshalTraits<P3>::unmarshal(*it++);
      slot(p1_,p2_,p3_);
      return Any();
    }
    static void marshal(SigC::Slot1<Any,const std::list<Any>&>& slot,P1 p1,P2 p2,P3 p3)
    {
      std::list<Any> params;
      params.push_back(MarshalTraits<P1>::marshal(p1)); params.push_back(MarshalTraits<P2>::marshal(p2)); params.push_back(MarshalTraits<P3>::marshal(p3));
      slot(params);
   }
};
#endif

template <class R,class P1,class P2,class P3>
SigC::Slot1<Any, const std::list<Any>&>
convert(const SigC::Slot3<R,P1,P2,P3>& s)
  { return SigCX::convert(s, &MarshalWrapper3<R,P1,P2,P3>::unmarshal); }

template <class R,class P1,class P2,class P3>
SigC::Slot3<R,P1,P2,P3>
convert(const SigC::Slot1<Any, const std::list<Any>&>& s)
  { return SigCX::convert(s, &MarshalWrapper3<R,P1,P2,P3>::marshal); }


/****************************************************************
***** Adaptor Convert SigC::Slot 4
****************************************************************/

template <class R,class P1,class P2,class P3,class P4>
class MarshalWrapper4
{
    typedef typename MarshalTraits<R>::ArgType TR; typedef typename MarshalTraits<P1>::ArgType TP1; typedef typename MarshalTraits<P2>::ArgType TP2; typedef typename MarshalTraits<P3>::ArgType TP3; typedef typename MarshalTraits<P4>::ArgType TP4;
  public:
    static Any unmarshal(SigC::Slot4<R,P1,P2,P3,P4>& slot, const std::list<Any>& params)
    {
      if (params.size() < 4)
        throw BadParam();
      std::list<Any>::const_iterator it = params.begin();
      TP1 p1_ = MarshalTraits<P1>::unmarshal(*it++); TP2 p2_ = MarshalTraits<P2>::unmarshal(*it++); TP3 p3_ = MarshalTraits<P3>::unmarshal(*it++); TP4 p4_ = MarshalTraits<P4>::unmarshal(*it++);
      Any retval = MarshalTraits<R>::marshal(slot(p1_,p2_,p3_,p4_));
      return retval;
    }
    static R marshal(SigC::Slot1<Any,const std::list<Any>&>& slot,P1 p1,P2 p2,P3 p3,P4 p4)
    {
      std::list<Any> params;
      params.push_back(MarshalTraits<P1>::marshal(p1)); params.push_back(MarshalTraits<P2>::marshal(p2)); params.push_back(MarshalTraits<P3>::marshal(p3)); params.push_back(MarshalTraits<P4>::marshal(p4));
      Any any_retval = slot(params);
      R retval;
      if (!any_retval.empty())
        retval = MarshalTraits<R>::unmarshal(any_retval);
      return retval;
    }
};

#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,class P2,class P3,class P4>
class MarshalWrapper4<void,P1,P2,P3,P4>
{
    typedef typename MarshalTraits<P1>::ArgType TP1; typedef typename MarshalTraits<P2>::ArgType TP2; typedef typename MarshalTraits<P3>::ArgType TP3; typedef typename MarshalTraits<P4>::ArgType TP4;
  public:
    static Any unmarshal(SigC::Slot4<void,P1,P2,P3,P4>& slot, const std::list<Any>& params)
    {
      if (params.size() < 4)
        throw BadParam();
      std::list<Any>::const_iterator it = params.begin();
      TP1 p1_ = MarshalTraits<P1>::unmarshal(*it++); TP2 p2_ = MarshalTraits<P2>::unmarshal(*it++); TP3 p3_ = MarshalTraits<P3>::unmarshal(*it++); TP4 p4_ = MarshalTraits<P4>::unmarshal(*it++);
      slot(p1_,p2_,p3_,p4_);
      return Any();
    }
    static void marshal(SigC::Slot1<Any,const std::list<Any>&>& slot,P1 p1,P2 p2,P3 p3,P4 p4)
    {
      std::list<Any> params;
      params.push_back(MarshalTraits<P1>::marshal(p1)); params.push_back(MarshalTraits<P2>::marshal(p2)); params.push_back(MarshalTraits<P3>::marshal(p3)); params.push_back(MarshalTraits<P4>::marshal(p4));
      slot(params);
   }
};
#endif

template <class R,class P1,class P2,class P3,class P4>
SigC::Slot1<Any, const std::list<Any>&>
convert(const SigC::Slot4<R,P1,P2,P3,P4>& s)
  { return SigCX::convert(s, &MarshalWrapper4<R,P1,P2,P3,P4>::unmarshal); }

template <class R,class P1,class P2,class P3,class P4>
SigC::Slot4<R,P1,P2,P3,P4>
convert(const SigC::Slot1<Any, const std::list<Any>&>& s)
  { return SigCX::convert(s, &MarshalWrapper4<R,P1,P2,P3,P4>::marshal); }


/****************************************************************
***** Adaptor Convert SigC::Slot 5
****************************************************************/

template <class R,class P1,class P2,class P3,class P4,class P5>
class MarshalWrapper5
{
    typedef typename MarshalTraits<R>::ArgType TR; typedef typename MarshalTraits<P1>::ArgType TP1; typedef typename MarshalTraits<P2>::ArgType TP2; typedef typename MarshalTraits<P3>::ArgType TP3; typedef typename MarshalTraits<P4>::ArgType TP4; typedef typename MarshalTraits<P5>::ArgType TP5;
  public:
    static Any unmarshal(SigC::Slot5<R,P1,P2,P3,P4,P5>& slot, const std::list<Any>& params)
    {
      if (params.size() < 5)
        throw BadParam();
      std::list<Any>::const_iterator it = params.begin();
      TP1 p1_ = MarshalTraits<P1>::unmarshal(*it++); TP2 p2_ = MarshalTraits<P2>::unmarshal(*it++); TP3 p3_ = MarshalTraits<P3>::unmarshal(*it++); TP4 p4_ = MarshalTraits<P4>::unmarshal(*it++); TP5 p5_ = MarshalTraits<P5>::unmarshal(*it++);
      Any retval = MarshalTraits<R>::marshal(slot(p1_,p2_,p3_,p4_,p5_));
      return retval;
    }
    static R marshal(SigC::Slot1<Any,const std::list<Any>&>& slot,P1 p1,P2 p2,P3 p3,P4 p4,P5 p5)
    {
      std::list<Any> params;
      params.push_back(MarshalTraits<P1>::marshal(p1)); params.push_back(MarshalTraits<P2>::marshal(p2)); params.push_back(MarshalTraits<P3>::marshal(p3)); params.push_back(MarshalTraits<P4>::marshal(p4)); params.push_back(MarshalTraits<P5>::marshal(p5));
      Any any_retval = slot(params);
      R retval;
      if (!any_retval.empty())
        retval = MarshalTraits<R>::unmarshal(any_retval);
      return retval;
    }
};

#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,class P2,class P3,class P4,class P5>
class MarshalWrapper5<void,P1,P2,P3,P4,P5>
{
    typedef typename MarshalTraits<P1>::ArgType TP1; typedef typename MarshalTraits<P2>::ArgType TP2; typedef typename MarshalTraits<P3>::ArgType TP3; typedef typename MarshalTraits<P4>::ArgType TP4; typedef typename MarshalTraits<P5>::ArgType TP5;
  public:
    static Any unmarshal(SigC::Slot5<void,P1,P2,P3,P4,P5>& slot, const std::list<Any>& params)
    {
      if (params.size() < 5)
        throw BadParam();
      std::list<Any>::const_iterator it = params.begin();
      TP1 p1_ = MarshalTraits<P1>::unmarshal(*it++); TP2 p2_ = MarshalTraits<P2>::unmarshal(*it++); TP3 p3_ = MarshalTraits<P3>::unmarshal(*it++); TP4 p4_ = MarshalTraits<P4>::unmarshal(*it++); TP5 p5_ = MarshalTraits<P5>::unmarshal(*it++);
      slot(p1_,p2_,p3_,p4_,p5_);
      return Any();
    }
    static void marshal(SigC::Slot1<Any,const std::list<Any>&>& slot,P1 p1,P2 p2,P3 p3,P4 p4,P5 p5)
    {
      std::list<Any> params;
      params.push_back(MarshalTraits<P1>::marshal(p1)); params.push_back(MarshalTraits<P2>::marshal(p2)); params.push_back(MarshalTraits<P3>::marshal(p3)); params.push_back(MarshalTraits<P4>::marshal(p4)); params.push_back(MarshalTraits<P5>::marshal(p5));
      slot(params);
   }
};
#endif

template <class R,class P1,class P2,class P3,class P4,class P5>
SigC::Slot1<Any, const std::list<Any>&>
convert(const SigC::Slot5<R,P1,P2,P3,P4,P5>& s)
  { return SigCX::convert(s, &MarshalWrapper5<R,P1,P2,P3,P4,P5>::unmarshal); }

template <class R,class P1,class P2,class P3,class P4,class P5>
SigC::Slot5<R,P1,P2,P3,P4,P5>
convert(const SigC::Slot1<Any, const std::list<Any>&>& s)
  { return SigCX::convert(s, &MarshalWrapper5<R,P1,P2,P3,P4,P5>::marshal); }


/****************************************************************
***** Adaptor Convert SigC::Slot 6
****************************************************************/

template <class R,class P1,class P2,class P3,class P4,class P5,class P6>
class MarshalWrapper6
{
    typedef typename MarshalTraits<R>::ArgType TR; typedef typename MarshalTraits<P1>::ArgType TP1; typedef typename MarshalTraits<P2>::ArgType TP2; typedef typename MarshalTraits<P3>::ArgType TP3; typedef typename MarshalTraits<P4>::ArgType TP4; typedef typename MarshalTraits<P5>::ArgType TP5; typedef typename MarshalTraits<P6>::ArgType TP6;
  public:
    static Any unmarshal(SigC::Slot6<R,P1,P2,P3,P4,P5,P6>& slot, const std::list<Any>& params)
    {
      if (params.size() < 6)
        throw BadParam();
      std::list<Any>::const_iterator it = params.begin();
      TP1 p1_ = MarshalTraits<P1>::unmarshal(*it++); TP2 p2_ = MarshalTraits<P2>::unmarshal(*it++); TP3 p3_ = MarshalTraits<P3>::unmarshal(*it++); TP4 p4_ = MarshalTraits<P4>::unmarshal(*it++); TP5 p5_ = MarshalTraits<P5>::unmarshal(*it++); TP6 p6_ = MarshalTraits<P6>::unmarshal(*it++);
      Any retval = MarshalTraits<R>::marshal(slot(p1_,p2_,p3_,p4_,p5_,p6_));
      return retval;
    }
    static R marshal(SigC::Slot1<Any,const std::list<Any>&>& slot,P1 p1,P2 p2,P3 p3,P4 p4,P5 p5,P6 p6)
    {
      std::list<Any> params;
      params.push_back(MarshalTraits<P1>::marshal(p1)); params.push_back(MarshalTraits<P2>::marshal(p2)); params.push_back(MarshalTraits<P3>::marshal(p3)); params.push_back(MarshalTraits<P4>::marshal(p4)); params.push_back(MarshalTraits<P5>::marshal(p5)); params.push_back(MarshalTraits<P6>::marshal(p6));
      Any any_retval = slot(params);
      R retval;
      if (!any_retval.empty())
        retval = MarshalTraits<R>::unmarshal(any_retval);
      return retval;
    }
};

#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,class P2,class P3,class P4,class P5,class P6>
class MarshalWrapper6<void,P1,P2,P3,P4,P5,P6>
{
    typedef typename MarshalTraits<P1>::ArgType TP1; typedef typename MarshalTraits<P2>::ArgType TP2; typedef typename MarshalTraits<P3>::ArgType TP3; typedef typename MarshalTraits<P4>::ArgType TP4; typedef typename MarshalTraits<P5>::ArgType TP5; typedef typename MarshalTraits<P6>::ArgType TP6;
  public:
    static Any unmarshal(SigC::Slot6<void,P1,P2,P3,P4,P5,P6>& slot, const std::list<Any>& params)
    {
      if (params.size() < 6)
        throw BadParam();
      std::list<Any>::const_iterator it = params.begin();
      TP1 p1_ = MarshalTraits<P1>::unmarshal(*it++); TP2 p2_ = MarshalTraits<P2>::unmarshal(*it++); TP3 p3_ = MarshalTraits<P3>::unmarshal(*it++); TP4 p4_ = MarshalTraits<P4>::unmarshal(*it++); TP5 p5_ = MarshalTraits<P5>::unmarshal(*it++); TP6 p6_ = MarshalTraits<P6>::unmarshal(*it++);
      slot(p1_,p2_,p3_,p4_,p5_,p6_);
      return Any();
    }
    static void marshal(SigC::Slot1<Any,const std::list<Any>&>& slot,P1 p1,P2 p2,P3 p3,P4 p4,P5 p5,P6 p6)
    {
      std::list<Any> params;
      params.push_back(MarshalTraits<P1>::marshal(p1)); params.push_back(MarshalTraits<P2>::marshal(p2)); params.push_back(MarshalTraits<P3>::marshal(p3)); params.push_back(MarshalTraits<P4>::marshal(p4)); params.push_back(MarshalTraits<P5>::marshal(p5)); params.push_back(MarshalTraits<P6>::marshal(p6));
      slot(params);
   }
};
#endif

template <class R,class P1,class P2,class P3,class P4,class P5,class P6>
SigC::Slot1<Any, const std::list<Any>&>
convert(const SigC::Slot6<R,P1,P2,P3,P4,P5,P6>& s)
  { return SigCX::convert(s, &MarshalWrapper6<R,P1,P2,P3,P4,P5,P6>::unmarshal); }

template <class R,class P1,class P2,class P3,class P4,class P5,class P6>
SigC::Slot6<R,P1,P2,P3,P4,P5,P6>
convert(const SigC::Slot1<Any, const std::list<Any>&>& s)
  { return SigCX::convert(s, &MarshalWrapper6<R,P1,P2,P3,P4,P5,P6>::marshal); }




} // namespace Script

} // namespace Yehia

#endif
